'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = responsiveValue;

var _isobject = require('isobject');

var _isobject2 = _interopRequireDefault(_isobject);

var _assignStyle2 = require('css-in-js-utils/lib/assignStyle');

var _assignStyle3 = _interopRequireDefault(_assignStyle2);

var _arrayEach = require('fast-loops/lib/arrayEach');

var _arrayEach2 = _interopRequireDefault(_arrayEach);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _toArray(arr) { return Array.isArray(arr) ? arr : Array.from(arr); }

function resolveResponsiveValues(style, properties, getMediaQueries, props) {
  var _loop = function _loop(property) {
    var value = style[property];

    // resolve nested styles
    if ((0, _isobject2.default)(value)) {
      style[property] = resolveResponsiveValues(value, properties, getMediaQueries, props);
    }

    if (properties[property]) {
      if (Array.isArray(value)) {
        var mediaQueries = getMediaQueries(value, props);

        var _value = _toArray(value),
            defaultValue = _value[0],
            mediaValues = _value.slice(1);

        style[property] = defaultValue;

        (0, _arrayEach2.default)(mediaQueries.slice(0, mediaValues.length), function (query, index) {
          (0, _assignStyle3.default)(style, _defineProperty({}, query, _defineProperty({}, property, mediaValues[index])));
        });
      }
    }
  };

  for (var property in style) {
    _loop(property);
  }

  return style;
}

function responsiveValue(getMediaQueries) {
  var properties = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

  return function (style, type, renderer, props) {
    return resolveResponsiveValues(style, properties, getMediaQueries, props);
  };
}